package de.fhg.iais.outdoor.simba.communication;

import java.io.File;

import javax.swing.filechooser.FileFilter;

public class NetFileFilter extends FileFilter {
	
	private String mType;
	private String mName;
	
	public NetFileFilter(String name, String type) {
		mType = type;
		mName = name;
	}

	public boolean accept(File f) {
		if(f.isDirectory()) {
			return true;
		}
		String name = f.getName();
		int index = name.lastIndexOf(".");
		if(index != -1) {
			if(name.substring(index + 1).equals(mType)) {
				return true;
			}
		}
		return false;
	}

	public String getDescription() {
		return mName + " (*." + mType + ")";
	}
	
	public String getType() {
		return mType;
	}
	
	
}


