package de.fhg.iais.outdoor.simba.core;

import java.awt.Polygon;
import java.util.Random;

public class Sensor extends SimObject {
	
	protected Random mRandom;
	protected double mVariance;

	public Sensor() {
		super();
		mRandom = new Random();
		mVariance = 0.0;
	}
	
	public Sensor(String name, double x, double y, double angle) {
		super(name, x, y, angle, new Polygon());
		mRandom = new Random();
		mVariance = 0.0;
	}
	
	public Sensor(String name, double x, double y, double angle, Polygon shape) {
		super(name, x, y, angle, shape);
		mRandom = new Random();
		mVariance = 0.0;
	}
	
	public double getSensorReading() {
		return 0.0;
	}
	
	public void setNoiseVariance(double variance) {
		mVariance = variance;
	}
	
	public double getNoiseVariance() {
		return mVariance;
	}
	
	
	/**
	 * Adds noise to a value.
	 * 
	 * @param value the value to modify.
	 * @return the value modified by a noise.
	 */
	public double addNoise(double value) {
		
		return value + ((mRandom.nextGaussian() * mVariance));
	}
	
}
