package de.fhg.iais.outdoor.simba.core;

import java.util.Iterator;
import java.util.Vector;

public class SimObjectSet {
	
	private Vector mObjects = new Vector();
	
	public SimObjectSet() {
	}
	
	public SimObjectSet(Vector elements) {
		mObjects.addAll(elements);
	}
	
	public boolean add(SimObject object) {
		if(object == null || mObjects.contains(object)) {
			return false;
		}
		mObjects.add(object);
		return true;
	}
	
	public boolean remove(SimObject object) {
		if(object == null || !mObjects.contains(object)) {
			return false;
		}
		mObjects.remove(object);
		return true;
	}
	
	public Iterator getIterator() {
		return mObjects.iterator();
	}
	
	public int getSize() {
		return mObjects.size();
	}
	
	/**
	 * This method returns a COPY of the internal Vector, so this method is relatively 
	 * expensive to use. If you want to access its members it is better to use the
	 * getIterator method and iterate with that Iterator over the elements.
	 * @return
	 */
	public Vector getElements() {
		return new Vector(mObjects);
	}

}
