package de.fhg.iais.outdoor.simba.evolution;

import de.fhg.iais.outdoor.simba.core.Simulator;
import de.fhg.iais.outdoor.simba.statistic.EvolutionStatistics;

public class SimbaDefaultEvolution {

	public SimbaDefaultEvolution() {
		

		EvolutionManager evoManager = Simulator.getInstance().getEvolutionManager();
		
		
		//add selection methods
		
		
		//set current selection method
		
		
		//add operators.
		evoManager.addEvolutionOperator(new EvolutionOperatorNNSimpleParentCopy(), 0);
		evoManager.addEvolutionOperator(new EvolutionOperatorNNRemoveNeuron(), 8);
		evoManager.addEvolutionOperator(new EvolutionOperatorNNRemoveSynapse(), 10);
		evoManager.addEvolutionOperator(new EvolutionOperatorNNRestrictSynapses(), 15);
		evoManager.addEvolutionOperator(new EvolutionOperatorNNAddNeuron(), 20);
		evoManager.addEvolutionOperator(new EvolutionOperatorNNChangeTransferFunction(), 25);
		evoManager.addEvolutionOperator(new EvolutionOperatorNNAddSynapse(), 30);
		evoManager.addEvolutionOperator(new EvolutionOperatorNNInitializeZeroSynapses(), 35);
		evoManager.addEvolutionOperator(new EvolutionOperatorESMutateStepSize(), 38);
		evoManager.addEvolutionOperator(new EvolutionOperatorNNChangeStrength(), 40);
		evoManager.addEvolutionOperator(new EvolutionOperatorNNChangeBias(), 50);
		
		evoManager.addEvolutionOperator(new EvolutionOperatorNNSynapseDiscretizer(), 300);
		evoManager.addEvolutionOperator(new EvolutionOperatorNNStructureValidator(), 1000);
		
		//deactivate some of the operators
		
		
		//Set the default evaluation method
		evoManager.setEvaluationMethod(new NeuralNetEvaluationMethod());
		
		//Add selection methods
		evoManager.addSelectionMethod(new SimpleRouletteWheelSelection());
		
	
		//If there is no initial individual, then one is created automatically
//		if(evoManager.getGeneration().isEmpty()) {
//			NeuralNet net = NeuralNet.createMinimalNet(Simulator.getInstance().getNeuralNetManager().getNeuralNetInterface());
//			if(net != null) {
//				EvolutionIndividual ind = new EvolutionIndividual(net);
//				Vector generation = new Vector();
//				generation.add(ind);
//				evoManager.replaceGeneration(generation);
//			}
//		}
		
		//Set default steps, tries, population size
		Simulator.getInstance().getScheduler().getNumberOfStepsValue().set(2000);
		Simulator.getInstance().getScheduler().getNumberOfTriesValue().set(6);
		Simulator.getInstance().getEvolutionManager().getMeanPopulationSizeValue().set(200);
		
		
		//Set evolution loggers and statistics
		new EvolutionStatistics();
		GenerationAutoLogger genLogger = new GenerationAutoLogger("Default");
		genLogger.setActive(false);
		
	}
}
