package de.fhg.iais.outdoor.simba.neuralnet;

public class TransferFunctionStep extends TransferFunction {
	
	private int mNumberOfSteps;
	
	public TransferFunctionStep(int numberOfSteps) {
		super("step" + numberOfSteps);
		mNumberOfSteps = numberOfSteps;
	}
	
	public double getLowerBound() {
		return -1.0;
	}

	public double getUpperBound() {
		return 1.0;
	}

	public double transferActivation(double activation) {
		activation = (1.0 + activation) * (((double) mNumberOfSteps) / 2.0);
		activation = (double) ((int) (activation));
		activation = (activation * (2.0 / (mNumberOfSteps - 1))) - 1.0;
		return Math.max(-1.0, Math.min(1.0, activation));
	}

}
