package de.fhg.iais.outdoor.simba.test;

import java.awt.geom.Point2D;

import de.fhg.iais.outdoor.simba.devices.Box;


public class TestActuator extends Box {
	
	public double mVelocity;
	private int mSteps;
	private int mMaxSteps;
	private boolean mUp;
	
	TestActuator(String name, double x, double y, double angle, double width, double height, double vel) {
		super(name, x, y, angle, width, height);
		mVelocity = vel;
		mSteps = 0;
		mUp = true;
		mMaxSteps = 2;
	}
	
	public void setSteps(int steps) {
		mMaxSteps = steps;
	}
	

	public boolean update() {
		boolean ok = super.update();
	
		Point2D.Double position = mPosition.get();
		if(mUp) {
			mSteps++;
			if(mSteps > mMaxSteps) {
				mUp = false;
			}
			mPosition.set(position.x + (Math.cos(Math.toRadians(mAngle.get())) * mVelocity), 
					position.y + (Math.sin(Math.toRadians(mAngle.get())) * mVelocity));
		}
		else {
			mSteps--;
			if(mSteps < -1 * mMaxSteps) {
				mUp = true;
			}
			mPosition.set(position.x - (Math.cos(Math.toRadians(mAngle.get())) * mVelocity),
						position.y + (Math.sin(Math.toRadians(mAngle.get())) * mVelocity));
		}
		
		return ok;
	}
	
	public void reset() {
		super.reset();
	}

}
