package de.fhg.iais.outdoor.simba.test;

import de.fhg.iais.outdoor.simba.core.Simulator;
import de.fhg.iais.outdoor.simba.fitness.FitnessFunction;
import de.fhg.iais.outdoor.simba.fitness.FitnessManager;
import junit.framework.TestCase;

public class TestFitnessManager extends TestCase {
	
	protected void tearDown() throws Exception {
		super.tearDown();
		Simulator.getInstance().clearInstance();
	}

	public void testFitnessManager() {
		FitnessManager fm = new FitnessManager();
		
		assertTrue(fm.getFitnessFunctions().isEmpty());
	
		AdapterFitnessFunction ff = new AdapterFitnessFunction("Test1");
		
		assertFalse(fm.addFitnessFunction(null));
		assertTrue(fm.addFitnessFunction(ff));
		assertEquals(fm.getFitnessFunctions().size(), 1);
		assertSame(fm.getFitnessFunctions().elementAt(0), ff);
		assertFalse(fm.addFitnessFunction(ff)); //already contained.
		assertEquals(fm.getFitnessFunctions().size(), 1);
		
		
		
	}

	public void testPrepareNextTry() {
		
	}

	public void testExecuteFitnessFunctions() {
		
	}

	public void testAddFitnessFunction() {
		
	}
	
	public class AdapterFitnessFunction extends FitnessFunction {
		
		public int mUpdateCounter;
		public double mFitnessToSet;
		
		public AdapterFitnessFunction(String name) {
			super(name);	
		}
		
		

		public void reset() {
		}

		public double calculateFitness() {
			mUpdateCounter++;
			return mFitnessToSet;
		}
		
		
	}

}
