package de.fhg.iais.outdoor.simba.value;

public class BooleanValue extends Value {
	
	private boolean mValue;
	
	public BooleanValue() {
		mValue = true;
	}
	
	public BooleanValue(boolean value) {
		mValue = value;
	}
	
	public synchronized void set(boolean value) {
		mValue = value;
		notifyValueChanged();
	}
	
	public synchronized boolean get() {
		return mValue;
	}
	
	/**
	 * Returns the content of the Value as String.
	 * This method should be implemented in a suitable way in each subclass.
	 * @return the string representation of the Values content.
	 */
	public String getValueAsString() {
		return mValue ? "T" : "F";
	}
	
	
	/**
	 * Sets the content of the Value from a String.
	 * This method should be implemented in a suitable way in each subclass.
	 * @return true if the parameter could successfully be parsed to set the value.
	 */
	public boolean setValueFromString(String value) {
		if(value.equals("1") || value.equalsIgnoreCase("t")
				|| value.equalsIgnoreCase("true")) 
		{
			if(!mValue) {
				set(true);
			}
			return true;
		}
		if(value.equals("0") || value.equalsIgnoreCase("f") 
				|| value.equalsIgnoreCase("false")) 
		{
			if(mValue) {
				set(false);
			}
			return true;
		}
		return false;
	}

}
