package de.fhg.iais.outdoor.simba.value;


public class IntValue extends Value {

	int mValue;
	
	public IntValue() {
		super();
	}
	
	public IntValue(int value) {
		super();
		mValue = value;
	}
	
	/**
	 * Returns the double value represented by this DoubelValue object.
	 * 
	 * @return the value of this DoubleValue.
	 */
	public synchronized int get() {
		return mValue;
	}
	
	/**
	 * Changes the encapsulated double value to the value given as parameter.
	 * 
	 * @param value the new value of this DoubleValue.
	 */
	public synchronized void set(int value) {
		mValue = value;
		notifyValueChanged();
	}
	
	/**
	 * Returns the content of the Value as String.
	 * This method should be implemented in a suitable way in each subclass.
	 * @return the string representation of the Values content.
	 */
	public String getValueAsString() {
		return Integer.toString(mValue);
	}
	
	
	/**
	 * Sets the content of the Value from a String.
	 * This method should be implemented in a suitable way in each subclass.
	 * @return true if the parameter could successfully be parsed to set the value.
	 */
	public boolean setValueFromString(String value) {
		try {
			int v = Integer.parseInt(value);
			if(v != mValue) {
				set(v);
			}
			return true;
		} catch (NumberFormatException e) {
			return false;
		}
	}
	
}
