package de.fhg.iais.outdoor.simba.value;

public class ObjectValue extends Value {

	Object mValue;
	
	public ObjectValue() {
		mValue = null;
	}
	
	public ObjectValue(Object value) {
		mValue = value;
	}
	
	/**
	 * Returns the double value represented by this DoubelValue object.
	 * 
	 * @return the value of this DoubleValue.
	 */
	public synchronized Object get() {
		return mValue;
	}
	
	/**
	 * Changes the encapsulated double value to the value given as parameter.
	 * 
	 * @param value the new value of this DoubleValue.
	 */
	public synchronized void set(Object value) {
		mValue = value;
		notifyValueChanged();
	}
	
	/**
	 * Returns the content of the Value as String.
	 * This method should be implemented in a suitable way in each subclass.
	 * @return the string representation of the Values content.
	 */
	public String getValueAsString() {
		if(mValue == null) {
			return "";
		}
		return mValue.toString();
	}
	
	
	/**
	 * Sets the content of the Value from a String.
	 * This method should be implemented in a suitable way in each subclass.
	 * @return true if the parameter could successfully be parsed to set the value.
	 */
	public boolean setValueFromString(String value) {
		return false;
	}
	
}
