package de.fhg.iais.outdoor.simba.value;

import de.fhg.iais.outdoor.simba.core.SimObject;

public class SimObjectValue extends Value {

	private SimObject mValue;
	
	public SimObjectValue() {
		mValue = null;
	}
	
	public SimObjectValue(SimObject value) {
		mValue = value;
	}
	
	/**
	 * Returns the double value represented by this DoubelValue object.
	 * 
	 * @return the value of this DoubleValue.
	 */
	public synchronized SimObject get() {
		return mValue;
	}
	
	/**
	 * Changes the encapsulated double value to the value given as parameter.
	 * 
	 * @param value the new value of this DoubleValue.
	 */
	public synchronized void set(SimObject value) {
		mValue = value;
		notifyValueChanged();
	}
	
	/**
	 * Returns the content of the Value as String.
	 * This method should be implemented in a suitable way in each subclass.
	 * @return the string representation of the Values content.
	 */
	public String getValueAsString() {
		if(mValue == null) {
			return "";
		}
		return mValue.getName();
	}
	
	
	/**
	 * Sets the content of the Value from a String.
	 * This method should be implemented in a suitable way in each subclass.
	 * @return true if the parameter could successfully be parsed to set the value.
	 */
	public boolean setValueFromString(String value) {
		//TODO change by name.
		return false;
	}
	
	
}
