package de.fhg.iais.outdoor.simba.value;

public class StringValue extends Value {
	
	private String mValue;
	
	public StringValue() {
		mValue = "";
	}
	
	public StringValue(String value) {
		mValue = value;
	}
	
	public synchronized void set(String value) {
		mValue = value;
		notifyValueChanged();
	}
	
	public synchronized String get() {
		return mValue;
	}
	
	/**
	 * Returns the content of the Value as String.
	 * This method should be implemented in a suitable way in each subclass.
	 * @return the string representation of the Values content.
	 */
	public String getValueAsString() {
		return mValue;
	}
	
	
	/**
	 * Sets the content of the Value from a String.
	 * This method should be implemented in a suitable way in each subclass.
	 * @return true if the parameter could successfully be parsed to set the value.
	 */
	public boolean setValueFromString(String value) {
		if(!mValue.equals(value)) {
			set(value);
		}
		return true;
	}

}
