package de.fhg.iais.outdoor.simba.visualization;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JCheckBox;
import javax.swing.JPanel;

public class HideableVisualization extends VisualizationArea {

	private JPanel mDisplay;
	private JCheckBox mHideCheckBox;
	private JPanel mContent;
	
	public HideableVisualization() {
		mDisplay = new JPanel(new BorderLayout());
		
		mHideCheckBox = new JCheckBox();
		mHideCheckBox.setSelected(false);
		mHideCheckBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(mContent == null) {
					mHideCheckBox.setSelected(false);
				}
				else {
					mContent.setVisible(mHideCheckBox.isSelected());
					notifyVisibilityChanged(mHideCheckBox.isSelected());
				}
			}
		});
		
		mContent = null;
		
		mDisplay.add(BorderLayout.WEST, mHideCheckBox);
	}
	
	protected boolean installVisualization(Visualization visu, String positionIdentifier) {
		if(visu != null && visu.getPanel() != null) {
			mContent = visu.getPanel();
			mDisplay.add(BorderLayout.CENTER, mContent);
			mHideCheckBox.setSelected(true);
			
			return true;
		}

		return false;
	}

	public JPanel getPanel() {
		return mDisplay;
	}

}
