package de.fhg.iais.outdoor.simba.visualization;

import java.awt.BorderLayout;

import javax.swing.JPanel;
import javax.swing.JScrollPane;

public class ScrollPaneVisualizationArea extends VisualizationArea {

	private JPanel mDisplay;
	private JScrollPane mScrollPane;
	
	public ScrollPaneVisualizationArea(int verticalScrollBarPolicy, int horizontalScrollBarPolicy) {
		mDisplay = new JPanel(new BorderLayout());
		mScrollPane = new JScrollPane(verticalScrollBarPolicy, horizontalScrollBarPolicy);
		mDisplay.add(BorderLayout.CENTER, mScrollPane);
	}
	
	protected boolean installVisualization(Visualization visu, String positionIdentifier) {
		if(visu == null) {
			return false;
		}
		JPanel panel = visu.getPanel();
		if(panel != null) {
			mScrollPane.setViewportView(panel);
			return true;
		}
		return false;
	}

	public JPanel getPanel() {
		return mDisplay;
	}

}
