package de.fhg.iais.outdoor.simba.visualization;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;

import de.fhg.iais.outdoor.simba.core.Simulator;
import de.fhg.iais.outdoor.simba.core.StepListener;

public class SingleStepButton implements Visualization, StepListener {
	
	
	private JPanel mDisplay;
	private JButton mStepButton;
	private boolean mWaitingForStep;
	
	
	public SingleStepButton() {
		mDisplay = new JPanel();
		mStepButton = new JButton("Step");
		mDisplay.add(mStepButton);
		mWaitingForStep = false;
		
		mStepButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				mWaitingForStep = true;
				Simulator.getInstance().pauseSimulation(false);
			}
		});
		Simulator.getInstance().getScheduler().addStepListener(this);
		
	}

	public JPanel getPanel() {
		return mDisplay;
	}

	public boolean cleanUp() {
		return true;
	}

	public boolean init() {
		return true;
	}

	public void stepCompleted(int stepNumber) {
		if(mWaitingForStep) {
			mWaitingForStep = false;
			Simulator.getInstance().pauseSimulation(true);
		}

	}

	public void stepStarted(int stepNumber) {
	}

}
