package de.fhg.iais.outdoor.simba.visualization;

import java.awt.BorderLayout;
import java.util.Timer;
import java.util.TimerTask;

import javax.swing.JLabel;
import javax.swing.JPanel;

import de.fhg.iais.outdoor.simba.core.StepListener;
import de.fhg.iais.outdoor.simba.core.Simulator;

public class StepsPerSecondDisplay implements Visualization, StepListener {
	
	JPanel mDisplay;
	JLabel mLabel;
	int mCounter;
	Timer mTimer;
	
	public StepsPerSecondDisplay() {
		mDisplay = new JPanel(new BorderLayout());
		mLabel = new JLabel("Steps per second: ");
		mDisplay.add(BorderLayout.CENTER, mLabel);
		mCounter = 0;
		mTimer = new Timer();
	}
	
	public boolean init() {
		boolean ok = true;
		Simulator.getInstance().getScheduler().addStepListener(this);
		mTimer.cancel();
		mTimer = new Timer();
		mTimer.scheduleAtFixedRate(new StepTimer(), 1000, 1000);
		mCounter = 0;
		return ok;
	}
	
	public boolean cleanUp() {
		boolean ok = true;
		mTimer.cancel();
		return ok;
	}
	
	public JPanel getPanel() {
		return mDisplay;
	}
	
	public void stepStarted(int stepNumber) {
		
	}
	
	public synchronized void stepCompleted(int step) {
		mCounter++;
	}
	
	public class StepTimer extends TimerTask {
	
		public synchronized void run() {
			mLabel.setText("Steps per second: " + mCounter);
			mCounter = 0;	
		}	
	}


}
