package de.fhg.iais.outdoor.simba.visualization;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JPanel;

import de.fhg.iais.outdoor.simba.core.Simulator;
import de.fhg.iais.outdoor.simba.value.BooleanValue;

public class TerminateTryButton implements Visualization {

	
	private JPanel mDisplay;
	private JButton mTerminateButton;
	private JCheckBox mEnableTerminateButtonCheckBox;
	private BooleanValue mTerminateTryValue;
	
	
	public TerminateTryButton() {
		mDisplay = new JPanel();
		mTerminateButton = new JButton("Terminate Try");
		mEnableTerminateButtonCheckBox = new JCheckBox();
		mEnableTerminateButtonCheckBox.setSelected(false);
		mDisplay.add(mEnableTerminateButtonCheckBox);
		mDisplay.add(mTerminateButton);
		
		mTerminateButton.setEnabled(false);
		mEnableTerminateButtonCheckBox.setEnabled(false);
		
		mTerminateButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(mTerminateTryValue != null && !mTerminateTryValue.get()) {
					mTerminateTryValue.set(true);
				}
			}
		});
		
		mEnableTerminateButtonCheckBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(mEnableTerminateButtonCheckBox.isSelected()) {
					mTerminateButton.setEnabled(true);
				}
				else {
					mTerminateButton.setEnabled(false);
				}
			}
		});
	}
	
	
	public JPanel getPanel() {
		return mDisplay;
	}

	public boolean cleanUp() {
		return true;
	}

	public boolean init() {

		mTerminateTryValue = Simulator.getInstance().getValueManager().getBooleanValue("/Simulation/TerminateCurrentTry");
		
		if(mTerminateTryValue != null) {
			mEnableTerminateButtonCheckBox.setEnabled(true);
			if(mEnableTerminateButtonCheckBox.isSelected()) {
				mTerminateButton.setEnabled(true);
			}
		}
		
		return true;
	}

}
