package de.fhg.iais.outdoor.simba.visualization;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import de.fhg.iais.outdoor.simba.core.Simulator;
import de.fhg.iais.outdoor.simba.neuralnet.NeuralNet;
import de.fhg.iais.outdoor.simba.neuralnet.NeuralNetAgentInterface;
import de.fhg.iais.outdoor.simba.xml.NeuralNetParser;

//import com.NeuralNetXML.EvoObjectType;
//import com.NeuralNetXML.EvolutionType;
//import com.NeuralNetXML.GenerationType;
//import com.NeuralNetXML.NetType;
//import com.NeuralNetXML.NeuralNetXMLDoc;
//import com.NeuralNetXML.NeuronType;
//import com.NeuralNetXML.PopulationType;

public class XMLTestVisualization implements Visualization {
	
	JPanel mDisplay;
	JTextField mTextField;
	JTextArea mTextArea;
	
	public XMLTestVisualization() {
		mDisplay = new JPanel(new BorderLayout());
		mTextField = new JTextField("D:\\tmp\\indy\\testnet.xml");
		mDisplay.add(mTextField, BorderLayout.NORTH);
		
		mTextArea = new JTextArea();
		JScrollPane scrollPane = new JScrollPane(mTextArea);
		mDisplay.add(scrollPane, BorderLayout.CENTER);
		
		mTextField.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
//				loadXML();
				try {
					BufferedReader reader = new BufferedReader(new FileReader(new File(mTextField.getText())));
					StringBuffer xml = new StringBuffer();
					xml.append(reader.readLine());
					NeuralNetAgentInterface netInterface = Simulator.getInstance().getNeuralNetManager().getNeuralNetInterface();
					NeuralNet net = NeuralNetParser.createNetFromEvosunXMLFile(mTextField.getText(), netInterface);
					if(net != null) {
						Simulator.getInstance().getNeuralNetManager().setCurrentNet(net);
					}
				} catch (FileNotFoundException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			}
		});
	}
	
	
	
//	public void loadXML() {
//		EvolutionType evolution = null;
//
//		NeuralNetXMLDoc doc = null;
//		
//		try {
//			doc = new NeuralNetXMLDoc();
//			evolution = new EvolutionType(doc.load(mTextField.getText()));
//		} catch (RuntimeException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//
//		if(evolution != null) {
//			System.out.println("Found: " + evolution.getGenerationCount());
//			StringBuffer buffer = new StringBuffer();
//			for(int i = 0; i < evolution.getGenerationCount(); ++i) {
//				try {
//					GenerationType gen = evolution.getGenerationAt(i);
//					buffer.append("" + gen.getIndex()).append("\n");
//				} catch (Exception e) {
//					// TODO Auto-generated catch block
//					e.printStackTrace();
//				}
//			}
//			mTextArea.setText(buffer.toString());
//			
//			if(doc != null) {
//				doc.save(mTextField.getText() + ".1.xml", evolution);
//			}
//		}
//		else {
//			System.out.println("Did not find the file.");
//		}
//		
//		
//		//save current network
//		
//		try {
//			doc = new NeuralNetXMLDoc();
//			evolution = new EvolutionType(doc, "", "", "Evolution");
//			
//			GenerationType gen = new GenerationType(evolution.getDomNode());
//			
//			gen.addIndex("0");
//			
//			PopulationType pop = new PopulationType(gen.getDomNode());
//			pop.addName("Bla");
//			pop.addIndex("0");
//			
//			EvoObjectType evo = new EvoObjectType(pop.getDomNode());
//			evo.addAge("0");
//			evo.addIndex("2");
//			evo.addOutPerf("123");
//			evo.addSysPerf("456");
//			
//			NetType net = new NetType(evo.getDomNode());
//			net.addTransferfunction("tanh");
//			net.addSynapseMode("dynamic");
//			
//			NeuronType neuron = new NeuronType(net.getDomNode());
//			neuron.addBias("0.0");
//			neuron.addLayer("hidden");
//			neuron.addProcess("normal");
//			
//			
//			net.addNeuron(neuron);
//			
//			evo.addNet(net);
//			
//			pop.addEvoObject(evo);
//			
//			gen.addPopulation(pop);
//			
//			
//			evolution.addGeneration(gen);
//			
//			doc.save(mTextField.getText() + ".new.xml", evolution);
//			
//			
//			
//		} catch (RuntimeException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
//		
//		
//	}

	public JPanel getPanel() {
		return mDisplay;
	}

	public boolean cleanUp() {
		return true;
	}

	public boolean init() {
		return true;
	}

}
