package de.fhg.iais.outdoor.simba.visualization.evolution;

import java.awt.BorderLayout;
import java.util.Iterator;
import java.util.Vector;


import javax.swing.Box;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import de.fhg.iais.outdoor.simba.core.ParameterElement;
import de.fhg.iais.outdoor.simba.core.Simulator;
import de.fhg.iais.outdoor.simba.evolution.EvolutionManager;
import de.fhg.iais.outdoor.simba.value.BooleanValue;
import de.fhg.iais.outdoor.simba.value.Value;
import de.fhg.iais.outdoor.simba.value.ValueChangedListener;
import de.fhg.iais.outdoor.simba.value.ValueManager;
import de.fhg.iais.outdoor.simba.visualization.Visualization;

public class ParameterPanel implements Visualization, ValueChangedListener {
	
	private JPanel mDisplay;
	private Box mContent;
	private BooleanValue mEvolutionEnabled;
	private Box mOperatorArea;
	private JScrollPane mScrollPanel;
	private Vector mParamPanels = new Vector();
	
	public ParameterPanel(Vector parameterElements) {
		this(parameterElements, null);
	}
	
	public ParameterPanel(Vector parameterElements, Vector ignoreList) {
		mDisplay = new JPanel(new BorderLayout());
		mOperatorArea = Box.createVerticalBox();
		
		mContent = Box.createVerticalBox();
		
		JPanel mainPanel = new JPanel(new BorderLayout());
		mScrollPanel = new JScrollPane(mainPanel);
		mainPanel.add(mContent, BorderLayout.NORTH);
		mDisplay.add(mScrollPanel, BorderLayout.CENTER);
		
		mContent.add(mOperatorArea);
		
		EvolutionManager em = Simulator.getInstance().getEvolutionManager();
		
		mEvolutionEnabled = em.getEvolutionEnabledValue();
		mEvolutionEnabled.addValueChangedListener(this);
		
		for(Iterator i = parameterElements.iterator(); i.hasNext();) {
			ParameterElement pe = (ParameterElement) i.next();
			ParameterElementPanel panel = new ParameterElementPanel(pe, ignoreList);
			mOperatorArea.add(panel);
			mParamPanels.add(panel);
		}
		
		mOperatorArea.revalidate();
		mScrollPanel.revalidate();
		
	}

	public JPanel getPanel() {
		return mDisplay;
	}

	public boolean cleanUp() {
		return true;
	}

	public boolean init() {

		return true;
	}

	public void valueChanged(Value value) {
		if(value != null) {
			if(value == mEvolutionEnabled) {
				if(mEvolutionEnabled.get()) {
					
				}
			}
		}
	}
	
	public void valueReplaced(Value oldValue, Value newValue) {
		mEvolutionEnabled = (BooleanValue) ValueManager.synchronizeValue(mEvolutionEnabled, oldValue, newValue, this);
	}
	
	public Vector getValuePanels() {
		Vector panels = new Vector();
		for(Iterator i = mParamPanels.iterator(); i.hasNext();) {
			panels.addAll(((ParameterElementPanel) i.next()).getValuePanels());
		}
		return panels;
	}
	

}
