package de.fhg.iais.outdoor.simba.visualization.evolution;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JPanel;

import de.fhg.iais.outdoor.simba.core.Simulator;
import de.fhg.iais.outdoor.simba.visualization.Visualization;

public class RestartGenerationButton implements Visualization {
	
	private JPanel mDisplay;
	private JCheckBox mActivateCheckbox;
	private JButton mRestartButton;
	
	public RestartGenerationButton() {
		mDisplay = new JPanel();
		
		mActivateCheckbox = new JCheckBox();
		mActivateCheckbox.setSelected(false);
		mActivateCheckbox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(mActivateCheckbox.isSelected()) {
					mRestartButton.setEnabled(true);
				}
				else {
					mRestartButton.setEnabled(false);
				}
			}
		});
		
		mRestartButton = new JButton("Restart Generation");
		mRestartButton.setEnabled(false);
		mRestartButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Simulator.getInstance().getEvolutionManager().restartCurrentGeneration();
				mActivateCheckbox.setSelected(false);
				mRestartButton.setEnabled(false);
			}
		});
		
		mDisplay.add(mActivateCheckbox);
		mDisplay.add(mRestartButton);
	}

	public JPanel getPanel() {
		return mDisplay;
	}

	public boolean cleanUp() {
		return true;
	}

	public boolean init() {
		return true;
	}

}
