package de.fhg.iais.outdoor.simba.visualization.neuron;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Point;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Vector;

public class NeuronActivityPlotter extends NeuronGraphPlotter {

	public NeuronActivityPlotter() {
		super("Activity");
	}
	
	public void plotHistroy(Graphics2D g2d, Vector neurons, Vector colors) {
		//lot the history of each neuron in the color of that neuron.
		int neuronIndex = 0;
		for(Iterator n= neurons.iterator(); n.hasNext();) {
			NeuronObject obj = (NeuronObject) n.next();
			
			LinkedList p = new LinkedList();
			if(obj.getNeuron() != null) {
				p = obj.getNeuron().getHistory();
			}
			synchronized(p) {
				g2d.setColor((Color) colors.elementAt(neuronIndex));				
				double pointDist = ((double) getCurrentWidth()) / ((double) p.size());
				
				int pointId = 0;
				Point point = new Point(0, 0);
				for(Iterator i = p.iterator(); i.hasNext();) {
					Double d = (Double) i.next();
					Point nextPoint = new Point((int) (pointId * pointDist), (int) translateValue(d.doubleValue()));
					if(pointId != 0) {
						g2d.drawLine(point.x, point.y, nextPoint.x, nextPoint.y);
					}
					pointId++;
					point = nextPoint;
				}
			}
			neuronIndex++;
		}
	}
}
