package de.fhg.iais.outdoor.simba.visualization.neuron;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Point;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Vector;

public class NeuronActivtySumPlotter extends NeuronGraphPlotter {
	
	public NeuronActivtySumPlotter() {
		super("ActivitySum");
		setScale(0.2);
	}

	public void plotHistroy(Graphics2D g2d, Vector neurons, Vector colors) {
		
		Vector plotLists = new Vector();
		
		int dataMinSize = Integer.MAX_VALUE;
		
		for(Iterator n = neurons.iterator(); n.hasNext();) {
			NeuronObject obj = (NeuronObject) n.next();
			
			if(obj.getNeuron() != null) {
				LinkedList list = obj.getNeuron().getHistory();
				synchronized(list) {
					Object[] data = list.toArray();
					plotLists.add(data);
					if(dataMinSize > data.length) {
						dataMinSize = data.length;
					}
				}
			}
		}
		if(!plotLists.isEmpty()) {

			int pointId = 0;
			Point point = new Point(0, 0);
			g2d.setColor(Color.RED);
			double pointDist = ((double) getCurrentWidth()) / ((double) dataMinSize);
			
			for(int i = 0; i < dataMinSize; ++i) {
				
				double sum = 0.0;
				for(Iterator j = plotLists.iterator(); j.hasNext();) {
					sum += ((Double) ((Object[]) j.next())[i]).doubleValue();
				}
				Point nextPoint = new Point((int) (pointId * pointDist), (int) translateValue(sum));
				if(pointId != 0) {
					g2d.drawLine(point.x, point.y, nextPoint.x, nextPoint.y);
				}
				pointId++;
				point = nextPoint;				
			}	

		}
	}

}
