package de.fhg.iais.outdoor.simba.visualization.neuron;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JPanel;

import de.fhg.iais.outdoor.simba.core.Simulator;
import de.fhg.iais.outdoor.simba.visualization.Visualization;

public class RearrangeSynapsesPanel implements Visualization {
	
	JPanel mDisplay;
	JButton mRearrangeButton;
	NeuronVisualizationEnvironment mNeuronEnvironment;
	
	public RearrangeSynapsesPanel(NeuronVisualizationEnvironment neuronEnvironment) {
		mNeuronEnvironment = neuronEnvironment;
		
		mDisplay = new JPanel();
		mRearrangeButton = new JButton("Rearrange");
		mRearrangeButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(mNeuronEnvironment !=  null) {
					synchronized (mNeuronEnvironment) {
						Vector synapses = mNeuronEnvironment.getSynapseObjects();
						for(Iterator i = synapses.iterator(); i.hasNext();) {
							((SynapseObject) i.next()).centerPosition();
						}
					}
					Simulator.getInstance().getNeuralNetManager().notifyNetworkStructureChanged(
							Simulator.getInstance().getNeuralNetManager().getCurrentNet());
				}
			}
		});
		mDisplay.add(mRearrangeButton);
	}

	public JPanel getPanel() {
		return mDisplay;
	}

	public boolean cleanUp() {
		return true;
	}

	public boolean init() {
		return true;
	}

}
